;Copywrite 2000 by Samuel Stearley


	include 	"os.h"
	xdef		_ti89
	xdef		_ti92plus
	xdef		_nostub




;----Process arguments------

	movem.l	d3-d7/a2-a6,-(a7)
	move.l	a7,a6
	move.l	200,a5
	move.l	1060(a5),a4
	move.l	(a4),a4		;got top of estack
	move.l	a4,-(a7)
	move.l	3852(a5),a0
	jsr		(a0)			;count arguments
	subq.w	#2,d0
	bne		ArgumentError
	cmp.b		#$2D,(a4)		;is 1st arg a string?
	bne		ArgumentError
	subq.l	#1,a4
	move.l	a4,-(a7)
DecLoop:
	tst.b		-(a4)
	bne.s		DecLoop
	cmp.b		#$2D,-(a4)		;is 2nd arg a string?
	bne		ArgumentError

;----Try to find it and if it does not exist then create it------

	move.l	384(a5),a0
	jsr		(a0)			;try to find it
	tst.l		d0
	bne		SkipCreation
	move.l	368(a5),a0
	jsr		(a0)			;So make it
SkipCreation:
	move.l	d0,-(a7)		;hsym
	beq		CreationError
	move.l	484(a5),a0
	jsr		(a0)			;dereference the symbol
	move.l	a0,a2
	btst.w	#9,$A(a0)
	bne		ErrorArchived
	btst.w	#3,$A(a0)
	bne		ErrorLocked
	move.w	$C(a0),d0		;get the handle
	bne		AppendData

;----Handle is null so create the handle and store stuff to it---

	moveq		#7,d3			;+2 for offset to the tag
						;+2 for offset to the cursor
						;+2 for how to begin the line
						;+1 for the tag.
	move.l	d3,-(a7)
	move.l	576(a5),a0
	jsr		(a0)			;allocate memory
	move.w	d0,-(a7)
	beq		CreationError
	move.l	600(a5),a0
	jsr		(a0)			;dereference it
	subq.l	#2,d3			;offset to the tag
	move.w	d3,(a0)
	move.w	#1,2(a0)		;offset to the cursor
	move.w	#$2000,4(a0)	;"/n"
	move.b	#$E0,7(a0)		;tag
	move.w	(a7),$C(a2)		;put handle to data
	bra		NowAddTheData

;----Handle exists so test to make sure it was good----

AppendData:
	move.w	d0,-(a7)
	move.l	2332(a5),a0
	jsr		(a0)			;handle to esi
	cmp.b		#$E0,(a0)		;is it a text var?
	bne		WrongTypeError	
	move.l	600(a5),a0
	jsr		(a0)			;dereference it

;----Now Append the data--------

NowAddTheData:
	move.w	(a7)+,d1		;get handle
	moveq		#-1,d3
	subq.l	#1,a4
DecLoop2:
	addq.l	#1,d3
	tst.b		-(a4)
	bne		DecLoop2
	move.l	d3,-(a7)
	addq.l	#2,(a7)
	moveq		#0,d0
	move.w	(a0),d0
	add.l		d0,(a7)		;new size to allocate
	move.w	d1,-(a7)		;the handle
	move.l	628(a5),a0
	jsr		(a0)			;reallocate the handle
	move.w	d0,-(a7)
	move.l	600(a5),a0
	jsr		(a0)			;dereference it.
	move.w	(a0),d0		;get size minus 2
	add.w		d3,(a0)		;increase offset to the tag
	lea		0(a0,d0),a0		;point to the place where data shall be copied to
	addq.l	#1,a4
CopyLoop:
	move.b	(a4)+,d0
	cmp.b		#'\',d0
	bne		SkipEscapeChar
	cmp.b		#'n',(a4)
	bne		SkipEscapeChar
	move.b	#$D,(a0)+
	move.b	#$20,(a0)+
	addq.l	#1,a4
	bra		CopyLoop
SkipEscapeChar
	move.b	d0,(a0)+
	bne		CopyLoop
	move.b	#$E0,(a0)		;new tag


;----Finally exit-----------

ErrorArchived:
CreationError:
ArgumentError:
WrongTypeError:
ErrorLocked:
	move.l	a6,a7
	movem.l	(a7)+,d3-d7/a2-a6
	rts


	END	
